# NewLendingPanel
Date: 2015-01-27

de.katho.kBorrow.gui

## Class NewLendingPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - de.katho.kBorrow.gui.NewLendingPanel

All Implemented Interfaces:
  java.awt.event.ActionListener, java.awt.event.FocusListener, java.awt.event.KeyListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible

    public class NewLendingPanel
    extends javax.swing.JPanel
    implements java.awt.event.ActionListener, java.awt.event.FocusListener, java.awt.event.KeyListener

Erzeugt das NewLendingPanel und leitet User-Interaktionen an den entsprechenden Controller weiter.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JPanel

`javax.swing.JPanel.AccessibleJPanel`

### Nested classes/interfaces inherited from class javax.swing.JComponent

`javax.swing.JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

Fields
`private int` `articleId` Artikel-ID, wird hier vor einer Ausleihe zwischengespeichert.
`private javax.swing.JButton` `btnCancel` Button: Abbrechen
`private javax.swing.JButton` `btnSave` Button: Speichern
`private org.jdesktop.swingx.JXDatePicker` `dpEstEndDate` Datepicker: Voraussichtliches Enddatum
`private FreeArticleTableModel` `freeArticleTableModel` Referenz auf das `FreeArticleTableModel`
`private KArticleModel` `kArticleModel` Referenz auf das `KArticleModel`
`private KLenderModel` `kLenderModel` Referenz auf das `KLenderModel`
`private KUserModel` `kUserModel` Referenz auf das `KUserModel`
`private javax.swing.JLabel` `lblArticleName` Label: Arikelname
`private javax.swing.JLabel` `lblStartDate` Label: Startdatum
`private javax.swing.JLabel` `lblStatus` Label: Status
`private NewLendingController` `newLendingController` Referenz auf den `NewLendingController`
`private static long` `serialVersionUID` Serial Version UID
`private javax.swing.JTextField` `tfName` Textfeld: Vorname des Ausleihers
`private javax.swing.JTextField` `tfStudentNumber` Textfeld: Matrikelnummer des Ausleihers
`private javax.swing.JTextField` `tfSurname` Textfeld: Nachname des Ausleihers
`private UserListModel` `userListModel` Referenz auf das `UserListModel`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`NewLendingPanel(DbConnector dbCon, java.util.HashMap<java.lang.String,KDataModel> models, Settings pSettings)` Erzeugt das Panel

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `actionPerformed(java.awt.event.ActionEvent pEvent)` ActionListener für gedrückte Buttons.
`void` `focusGained(java.awt.event.FocusEvent pEvent)` FocusListener für erhaltenen Fokus.
`void` `focusLost(java.awt.event.FocusEvent pEvent)` FocusListener für verlorenen Focus.
`void` `keyPressed(java.awt.event.KeyEvent pKeyPress)` KeyListener für gedrückte Tasten.
`void` `keyReleased(java.awt.event.KeyEvent e)` KeyListener für losgelassene Tasten Nicht implementiert!
`void` `keyTyped(java.awt.event.KeyEvent e)` KeyListener für eine getippte Taste (Drücken und Loslassen) Nicht implementiert!
`private void` `resetForm()` Setzt das Formular zurück.
`private void` `saveButtonPressed()` Führt die Aktionen aus, die geschehen, wenn der Speichern-Button gedrückt wird.
`void` `setModeNewLending(int id)` Holt ausgewählten Artikel aus der Tabelle und trägt einige Werte für eine neue Ausleihe in das Formular.

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serial Version UID

See Also:
  Constant Field Values

#### tfName

    private javax.swing.JTextField tfName

Textfeld: Vorname des Ausleihers

#### tfSurname

    private javax.swing.JTextField tfSurname

Textfeld: Nachname des Ausleihers

#### tfStudentNumber

    private javax.swing.JTextField tfStudentNumber

Textfeld: Matrikelnummer des Ausleihers

#### lblStatus

    private javax.swing.JLabel lblStatus

Label: Status

#### lblStartDate

    private javax.swing.JLabel lblStartDate

Label: Startdatum

#### lblArticleName

    private javax.swing.JLabel lblArticleName

Label: Arikelname

#### btnCancel

    private javax.swing.JButton btnCancel

Button: Abbrechen

#### btnSave

    private javax.swing.JButton btnSave

Button: Speichern

#### dpEstEndDate

    private org.jdesktop.swingx.JXDatePicker dpEstEndDate

Datepicker: Voraussichtliches Enddatum

#### kArticleModel

    private KArticleModel kArticleModel

Referenz auf das `KArticleModel`

#### kUserModel

    private KUserModel kUserModel

Referenz auf das `KUserModel`

#### kLenderModel

    private KLenderModel kLenderModel

Referenz auf das `KLenderModel`

#### userListModel

    private UserListModel userListModel

Referenz auf das `UserListModel`

#### freeArticleTableModel

    private FreeArticleTableModel freeArticleTableModel

Referenz auf das `FreeArticleTableModel`

#### newLendingController

    private NewLendingController newLendingController

Referenz auf den `NewLendingController`

#### articleId

    private int articleId

Artikel-ID, wird hier vor einer Ausleihe zwischengespeichert.

### Constructor Detail

#### NewLendingPanel

    public NewLendingPanel(DbConnector dbCon,
                           java.util.HashMap<java.lang.String,KDataModel> models,
                           Settings pSettings)
                    throws java.io.IOException

Erzeugt das Panel

Parameters:
  `dbCon` - Referenz auf die Datenbankverbindung.
  `models` - Referenz auf die HashMap mit KDataModels.
  `pSettings` - Referenz auf die Settings, wird für `NewLendingController` benötigt.
Throws:
  `java.io.IOException` - Wenn Probleme beim erstellen des `NewLendingTableButton` auftreten.

### Method Detail

#### resetForm

    private void resetForm()

Setzt das Formular zurück.

#### saveButtonPressed

    private void saveButtonPressed()
                            throws java.lang.Exception

Führt die Aktionen aus, die geschehen, wenn der Speichern-Button gedrückt wird.

Übergibt Inhalt des Formulars an den NewLendingController und gibt je nach Rückgabecode eine andere Statusmeldung aus.

Throws:
  `java.lang.Exception` - Wenn Fehler in `NewLendingController.newLending(int, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.util.Date, java.lang.String)` nicht abgefangen werden können.

#### setModeNewLending

    public void setModeNewLending(int id)

Holt ausgewählten Artikel aus der Tabelle und trägt einige Werte für eine neue Ausleihe in das Formular.

Parameters:
  `id` - ID des ausgewählten Artikels.

#### actionPerformed

    public void actionPerformed(java.awt.event.ActionEvent pEvent)

ActionListener für gedrückte Buttons.

Specified by:
  `actionPerformed` in interface `java.awt.event.ActionListener`
Parameters:
  `pEvent` - ActionEvent, das den Listener aufruft.

#### focusGained

    public void focusGained(java.awt.event.FocusEvent pEvent)

FocusListener für erhaltenen Fokus.

Nicht implementiert!

Specified by:
  `focusGained` in interface `java.awt.event.FocusListener`
Parameters:
  `pEvent` - FocusEvent, das den Listener aufruft.

#### focusLost

    public void focusLost(java.awt.event.FocusEvent pEvent)

FocusListener für verlorenen Focus.

Prüft, ob andere Ausleiher-Textfelder (Vorname, Nachname, Matr.-Nr.) automatisch ausgefüllt werden können.

Specified by:
  `focusLost` in interface `java.awt.event.FocusListener`
Parameters:
  `pEvent` - FocusEvent, das den Listener aufruft.

#### keyPressed

    public void keyPressed(java.awt.event.KeyEvent pKeyPress)

KeyListener für gedrückte Tasten.

Fängt den Druck der Entertaste ab und ruft `saveButtonPressed()` auf.

Specified by:
  `keyPressed` in interface `java.awt.event.KeyListener`
Parameters:
  `pKeyPress` - KeyEvent, das den Listener aufruft.

#### keyReleased

    public void keyReleased(java.awt.event.KeyEvent e)

KeyListener für losgelassene Tasten

Nicht implementiert!

Specified by:
  `keyReleased` in interface `java.awt.event.KeyListener`
Parameters:
  `e` - KeyEvent, das den Listener aufruft.

#### keyTyped

    public void keyTyped(java.awt.event.KeyEvent e)

KeyListener für eine getippte Taste (Drücken und Loslassen)

Nicht implementiert!

Specified by:
  `keyTyped` in interface `java.awt.event.KeyListener`
Parameters:
  `e` - Keyevent, das den Listener aufruft.